﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btndata As Button
	Private btnreport As Button
	Private ta1 As TextArea
	Private wv1 As WebView
	Private reclst As List
	Private htmlstring As String = ""
	Private itemlst As List
	Private valuesmap As Map
	Private headlst As List
	Private fldlst As List
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	reclst.Initialize
	itemlst.Initialize
	valuesmap.Initialize
	headlst.Initialize
	fldlst.Initialize
	itemlst = File.ReadList(File.DirAssets,"itemrow.sld")
	For i = 0 To itemlst.Size -1
		valuesmap = itemlst.Get(i).As(JSON).ToMap
		Dim txt As String = valuesmap.Get("text")
		If txt <> "" Then
			If txt.Contains("[") = False Then
				Dim fld As String = valuesmap.Get("text")
				headlst.Add(fld & ";" & valuesmap.Get("width") & ";" _
						 & valuesmap.Get("alignment") & ";" & valuesmap.Get("fontfamily") & _
						 ";" & valuesmap.Get("isbold") & ";" & valuesmap.Get("gradient1") & _
						 ";" & valuesmap.Get("gradient2"))
			Else
				Dim fld As String = valuesmap.Get("text")
				fldlst.Add(fld.SubString2(1,fld.Length-1) & ";" & valuesmap.Get("width") & ";" _
						 & valuesmap.Get("alignment") & ";" & valuesmap.Get("fontfamily") & _
						 ";" & valuesmap.Get("isbold") & ";" & valuesmap.Get("gradient1") & _
						 ";" & valuesmap.Get("gradient2"))					
			End If
		End If
	Next
	'Log(fldlst)
End Sub
Private Sub btnreport_Click
	htmlstring = "<html><head><title>Items report</title></head><body>"
	htmlstring = htmlstring & "<table><tr>"
	' column headers
	For i = 0 To fldlst.Size -1
		Dim fstr As String = get_field_values(headlst.Get(i),"")
		htmlstring = htmlstring & fstr
	Next
	htmlstring = htmlstring & "</tr><tr>"
	' records
	For j = 1 To reclst.Size -1
		Dim rec As String = reclst.Get(j)
		Dim flds As List = Regex.Split(";",rec)
		For i = 0 To flds.Size -1
			Dim fstr As String = get_field_values(fldlst.Get(i),flds.Get(i))
			htmlstring = htmlstring & fstr
		Next
		' record total
		Dim total As Double = flds.Get(2) * flds.Get(3)
		Dim fstr As String = get_field_values(fldlst.Get(4),total)
		htmlstring = htmlstring & fstr
		htmlstring = htmlstring & "</tr><tr>"
	Next
	htmlstring = htmlstring & "</tr></table>"
	'
	wv1.LoadHtml(htmlstring)
End Sub
Private Sub get_field_values(fld As String, value As String) As String
	Dim lst As List = Regex.Split(";",fld)
	Dim fldname As String = lst.Get(0)
	Dim fldwidth As String = lst.get(1)
	Dim fldalign As String = lst.get(2)
	Dim fldfont As String = lst.get(3)
	Dim fldbold As String = lst.get(4)
	Dim fldgrad1 As String = lst.get(5)
	Dim fldgrad2 As String = lst.get(6)
	If value = "" Then value = fldname
	If fldbold = "true" Then
		fldbold = "bold"
	Else
		fldbold = "normal"	
	End If
	If fldalign.Contains("LEFT") Then
		fldalign = "left"
	Else
		fldalign = "right"
	End If
	Return "<td style='text-align:" & fldalign & ";font-family:" & fldfont & _
		   ";font-weight:" & fldbold & ";background-image:linear-gradient(" & fldgrad1 & "," & fldgrad2 & ");'" & _
		   " width=" & fldwidth & ">" & value & "</td>"
End Sub
Private Sub btndata_Click
	ta1.Text = ""
	reclst = File.ReadList(File.DirAssets,"items.csv")
	For i = 0 To reclst.Size -1
		ta1.Text = ta1.Text & reclst.Get(i) & CRLF
	Next
End Sub